'use strict';Object.defineProperty(exports,'__esModule',{value:true});//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//


// Taken from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Math/random
function getRandomInt(max) {
  return Math.floor(Math.random() * Math.floor(max));
}

var script = {
  name: 'iOS13SegmentedControl',
  props: {
    value: {
      required: true,
      type: [Number, String]
    },
    segments: {
      required: true,
      type: Array
    },
    elementName: {
      type: String,
      required: false,
      default: function () { return '' + getRandomInt(100000); }
    }
  },
  data: function data() {
    return {
      selectedSegmentWidth: 0,
    };
  },


  mounted: function mounted() {
    window.addEventListener('resize', this.recalculateSelectedSegmentWidth);
  },
  
  beforeDestroy: function beforeDestroy() {
    window.removeEventListener('resize', this.recalculateSelectedSegmentWidth);
  },

  computed: {
    selectedSegmentId: {
      get: function get() {
        return this.value;
      },
      set: function set(segmentId) {
        this.$emit("input", segmentId);
      }
    },
    selectedSegmentIndex: function selectedSegmentIndex() {
      var this$1 = this;

      return this.segments.findIndex(function (segment) { return segment.id === this$1.value; });
    },
    pillTransformStyles: function pillTransformStyles() {
      return "transform:translateX(" + (this.selectedSegmentWidth * this.selectedSegmentIndex) + "px)";
    }
  },

  methods: {
    recalculateSelectedSegmentWidth: function recalculateSelectedSegmentWidth() {
      var this$1 = this;

      // Wait for UI to rerender before measuring
      this.$nextTick(function (){
        var segmentElement = document.querySelector(("input[type='radio'][value='" + (this$1.value) + "']"));
        this$1.selectedSegmentWidth = segmentElement && segmentElement.offsetWidth;
      });
    }
  },

  watch: {
    // If segments are added, edited, or removed
    segments: function segments() {
      this.recalculateSelectedSegmentWidth();
    },
    // If the segment is changed programmatically
    value: function value() {
      this.recalculateSelectedSegmentWidth();
    }
  }
};function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    var options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    var hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            var originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            var existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}function createInjectorSSR(context) {
    if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
        context = __VUE_SSR_CONTEXT__;
    }
    if (!context)
        { return function () { }; }
    if (!('styles' in context)) {
        context._styles = context._styles || {};
        Object.defineProperty(context, 'styles', {
            enumerable: true,
            get: function () { return context._renderStyles(context._styles); }
        });
        context._renderStyles = context._renderStyles || renderStyles;
    }
    return function (id, style) { return addStyle(id, style, context); };
}
function addStyle(id, css, context) {
    var group =  css.media || 'default' ;
    var style = context._styles[group] || (context._styles[group] = { ids: [], css: '' });
    if (!style.ids.includes(id)) {
        style.media = css.media;
        style.ids.push(id);
        var code = css.source;
        style.css += code + '\n';
    }
}
function renderStyles(styles) {
    var css = '';
    for (var key in styles) {
        var style = styles[key];
        css +=
            '<style data-vue-ssr-id="' +
                Array.from(style.ids).join(' ') +
                '"' +
                (style.media ? ' media="' + style.media + '"' : '') +
                '>' +
                style.css +
                '</style>';
    }
    return css;
}/* script */
var __vue_script__ = script;

/* template */
var __vue_render__ = function () {var _vm=this;var _h=_vm.$createElement;var _c=_vm._self._c||_h;return _c('div',[_vm._ssrNode("<div class=\"vue-ios13-segmented-control\"><span class=\"selection-pill\""+(_vm._ssrStyle(null,_vm.pillTransformStyles, null))+"></span> "+(_vm._ssrList((_vm.segments),function(segment){return ("<div class=\"option\"><input type=\"radio\""+(_vm._ssrAttr("id",segment.id))+(_vm._ssrAttr("name",_vm.elementName))+(_vm._ssrAttr("value",segment.id))+(_vm._ssrAttr("checked",_vm._q(_vm.selectedSegmentId,segment.id)))+"> <label"+(_vm._ssrAttr("for",segment.id))+"><span>"+_vm._ssrEscape(_vm._s(segment.title))+"</span></label></div>")}))+"</div>")])};
var __vue_staticRenderFns__ = [];

  /* style */
  var __vue_inject_styles__ = function (inject) {
    if (!inject) { return }
    inject("data-v-592687f2_0", { source: ".vue-ios13-segmented-control{font-family:-apple-system,system-ui,BlinkMacSystemFont,\"Segoe UI\",Roboto,\"Helvetica Neue\",Arial,sans-serif;text-rendering:geometricPrecision;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale;-webkit-overflow-scrolling:touch!important;touch-action:manipulation!important;-webkit-tap-highlight-color:transparent;--background:rgba(239,239,240,1);background:var(--background);border-radius:9px;margin:0;padding:2px;border:none;outline:0;display:grid;grid-auto-flow:column;grid-auto-columns:1fr;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;overflow-x:scroll}.vue-ios13-segmented-control label{cursor:inherit}.vue-ios13-segmented-control .option{display:flex;justify-content:center;align-items:center;position:relative;cursor:pointer}.vue-ios13-segmented-control .option:active input:not(:checked)+label span,.vue-ios13-segmented-control .option:focus input:not(:checked)+label span,.vue-ios13-segmented-control .option:hover input:not(:checked)+label span{opacity:.2}.vue-ios13-segmented-control .option:active input:not(:checked)+label span{transform:scale(.95)}.vue-ios13-segmented-control .option:first-of-type{grid-column:1;grid-row:1;box-shadow:none}.vue-ios13-segmented-control .option:first-of-type input::before{opacity:0}.vue-ios13-segmented-control .option:last-of-type input::after{opacity:0}.vue-ios13-segmented-control .option input{position:absolute;top:0;left:0;right:0;bottom:0;width:100%;height:100%;padding:0;margin:0;-webkit-appearance:none;-moz-appearance:none;appearance:none;outline:0;border:none}.vue-ios13-segmented-control .option input:checked+label{cursor:default}.vue-ios13-segmented-control .option input:checked+label::after,.vue-ios13-segmented-control .option input:checked+label::before{background:var(--background);z-index:1}.vue-ios13-segmented-control .option input::after,.vue-ios13-segmented-control .option input::before{content:\"\";width:1px;background:rgba(142,142,147,.15)!important;position:absolute;top:10%;bottom:10%;border-radius:10px;will-change:background;-webkit-transition:background .2s ease;transition:background .2s ease}.vue-ios13-segmented-control .option input::before{left:0;transform:translateX(-.5px)}.vue-ios13-segmented-control .option input::after{right:0;transform:translateX(.5px)}.vue-ios13-segmented-control .option label{position:relative;display:block;text-align:center;padding:3px 6vmin;margin-bottom:2px;background:rgba(255,255,255,0);font-weight:500;color:#000;font-size:14px}.vue-ios13-segmented-control .option label span{display:block;position:relative;z-index:2;-webkit-transition:all .2s ease;transition:all .2s ease;will-change:transform}.vue-ios13-segmented-control .selection-pill{background:#fff;border:.5px solid rgba(0,0,0,.04);box-shadow:0 3px 8px 0 rgba(0,0,0,.12),0 3px 1px 0 rgba(0,0,0,.04);border-radius:7px;grid-column:1;grid-row:1;z-index:2;will-change:transform;-webkit-transition:transform .2s ease;transition:transform .2s ease}", map: undefined, media: undefined });

  };
  /* scoped */
  var __vue_scope_id__ = undefined;
  /* module identifier */
  var __vue_module_identifier__ = "data-v-592687f2";
  /* functional template */
  var __vue_is_functional_template__ = false;
  /* style inject shadow dom */
  

  
  var __vue_component__ = /*#__PURE__*/normalizeComponent(
    { render: __vue_render__, staticRenderFns: __vue_staticRenderFns__ },
    __vue_inject_styles__,
    __vue_script__,
    __vue_scope_id__,
    __vue_is_functional_template__,
    __vue_module_identifier__,
    false,
    undefined,
    createInjectorSSR,
    undefined
  );// Import vue component

// install function executed by Vue.use()
function install(Vue) {
  if (install.installed) { return; }
  install.installed = true;
  Vue.component('ios13-segmented-control', __vue_component__);
}

// Create module definition for Vue.use()
var plugin = {
  install: install,
};

// To auto-install when vue is found
/* global window global */
var GlobalVue = null;
if (typeof window !== 'undefined') {
  GlobalVue = window.Vue;
} else if (typeof global !== 'undefined') {
  GlobalVue = global.Vue;
}
if (GlobalVue) {
  GlobalVue.use(plugin);
}

// Inject install function into component - allows component
// to be registered via Vue.use() as well as Vue.component()
__vue_component__.install = install;

// It's possible to expose named exports when writing components that can
// also be used as directives, etc. - eg. import { RollupDemoDirective } from 'rollup-demo';
// export const RollupDemoDirective = component;
exports.default=__vue_component__;